program FontTst7;
uses ObjGfx8,Keys,Font8;

const FontFile='WC2.BLF';
const FontFile2='ROMAN1.DPF';
const TestFile='FONTTST7.PAS';  {test file to read in}
const FieldWidth=85;
const FieldHeight=25;
const VidMode=_800x600x8bpp;

type TBuf1=object(TGfx8)
       Font                     : TBlitFont8;
       TextField                : array[0..FieldHeight-1] of string[FieldWidth];
       Width                    : word;
       Height                   : word;
       StartingField            : word;
       constructor init;
       procedure Scroll;
       procedure AddString(const s:string);
       procedure Display;
       destructor done; virtual;

     end;

type NewVesa8=object(TScreen8)
       Buf                      : TBuf1;
       Font                     : TDPFont8;
       constructor init;
       procedure run;
       destructor done; virtual;
     end;

procedure Abort(const s:string);
begin
 writeln(s);
 halt
end;

constructor TBuf1.init;
var i:word;
begin
 inherited init;
 Font.Init(self);
 if not Font.Load(FontFile) then
  Abort('Error loading font file: '+FontFile);

 Width:=Font.TextWidth('M');
 Height:=Font.TextHeight('M');
 for i:=low(TextField) to high(TextField) do
  TextField[i]:='';

 StartingField:=0;

 if not GetMem(FieldWidth*Width,FieldHeight*Height) then
  Abort('Error allocating memory for buffer')
end;

procedure TBuf1.Scroll;
begin
 if StartingField=FieldHeight-1 then StartingField:=0 else inc(StartingField);
end;

procedure TBuf1.AddString;
begin
 TextField[StartingField]:=s;
 Scroll;
end;

procedure TBuf1.Display;
var xx,count:word;

begin
 clear(1);  {set the background colour}
 count:=0;
 xx:=0;
 repeat
  Font.PutText(0,count*Height,TextField[(StartingField+count) mod FieldHeight]);
  inc(count)
 until count=FieldHeight
end;

destructor TBuf1.Done;
begin
 inherited done;
 Font.Done
end;

constructor NewVesa8.Init;
begin
 inherited init;
 Buf.Init;
 Font.Init(self);
 if not Font.Load(FontFile2) then
  Abort('Error loading font file: '+FontFile2);
 if not SetMode(VidMode) then
  Abort('Error setting video mode');

 setrgbpalette(252,0,0,0);
 setrgbpalette(253,31,31,31);
 setrgbpalette(254,53,53,53);
 setrgbpalette(255,63,63,63);
end;

procedure NewVesa8.Run;
var yy:word;
    f:text;
    s:string;
begin
 assign(f,TestFile); {This file had better exist}
 {$I-}
 reset(f);
 {$I+}
 {fill the inital buffer}
 yy:=0;
 while not eof(f) and (yy<FieldHeight) do
  with Buf do
   begin
    readln(f,s);
    AddString(s);
    inc(yy)
   end;

 Font.SetColor(14);
 Font.PutText(0,GetMaxY-Font.Height,'Press any key to scroll.  ESC quits');
 Font.SetColor(4);

 repeat
  Buf.Display;  {Draw the text to the buffer}
  flip(buf);    {copy the buffer to the screen}

  if eof(f) then Font.PutText(0,Buf.GetMaxY+1,'End of file')
  else
   with Buf do
    begin
     readln(f,s);
     AddString(s);
    end

 until readkey=#27;  {repeat until an ESC}
 close(f)
end;

destructor NewVesa8.Done;
begin
 inherited done;
 Buf.Done;
 Font.Done
end;

var Screen:NewVesa8;
begin
 Screen.Init;
 screen.run;
 Screen.Done;
end.